// ************************************************
//    AVC_CommFuncs.cpp
//
//
//		Biblioteca de funes usadas em conjunto 
//	com o exemplo de Ambiente Virtual 
//	Colaborativo (AVC.cpp)
//
//
//  Author: Marcio Serolli Pinho
//	Email: pinho@inf.pucrs.br		 
//	Homepages:
//		http://www.smallvr.org
//		http://grv.inf.pucrs.br
//		http://www.inf.pucrs.br/~pinho
//
//	Porto Alegre, Brazil, 2003.
// ************************************************
#include <stdio.h>

// for some utility functions
#include "Utilities.h"


#include "RemoteMemory.h"

#include "AVC_ClientFunc.h"
static int ServerOK = 0;


static int MyID = 0;

// **********************************************************************
// int IsPartnerOnLine()
//		verifica se o partner j est conectado.
//
// **********************************************************************
int IsPartnerOnLine()
{
	int dado = 0;

	if (!ServerOK)
		return FALSE;

	if (MyID == ID_CLIENT_ONE)
    {
		ReadFromRemoteMemoryIP (&dado, ID_CLIENT_TWO*sizeof(int),  sizeof(int));	
		if (dado == ID_CLIENT_TWO)
			return TRUE;
		else return FALSE;
	}

	 if (MyID == ID_CLIENT_TWO)
     {
		 ReadFromRemoteMemoryIP (&dado, ID_CLIENT_ONE*sizeof(int),  sizeof(int));		    
		 if (dado == ID_CLIENT_ONE)
			 return TRUE;
		 else return FALSE;
	 }

	 return FALSE;

}

// **********************************************************************
//  void ConnectToTheServer(int &ID)
//		faz a conexo com o servidor e cria um ID para o usurio
//
// **********************************************************************
void ConnectToTheServer(int &ID)
{
	int result;
	char serverIP[30] = "127.0.0.1";  // Nro IP do servidor
	unsigned int port = 1001;  // porta de conexo com o servidor

	int dado;
		
	result = ConnectToRemoteMemory ( serverIP, port );
	if ( !result ) {  
		printf ( "Unable to connect to Memory Server at %s.\n", serverIP );
		printf ( "Pressione uma tecla para Continuar.");
		setWindowTitles("Cliente no conectado ao Servidor!!");
		ID = -1; // cliente no conectado
		getchar();		
		return;     
	}
	printf ("Conexo bem sucedida !\n"); 
	ServerOK = 1;

	MyID = 0;
	// verifica se j existe um cliente ONE
	ReadFromRemoteMemoryIP (&dado, ID_CLIENT_ONE*sizeof(int),  sizeof(int));	
	if (dado == 0)
	{
		dado = ID_CLIENT_ONE;
		WriteOnRemoteMemoryIP (&dado, ID_CLIENT_ONE*sizeof(int),  sizeof(int));
		MyID = ID_CLIENT_ONE;
		printf("Sou o cliente UM!\n");
		setWindowTitles("Client ONE !!");
	}
	else 	
	{
		if (dado == ID_CLIENT_ONE) // J existe um cliente ONE, logo este  o cliente DOIS
		{
			dado = ID_CLIENT_TWO;
			WriteOnRemoteMemoryIP (&dado, ID_CLIENT_TWO * sizeof(int),  sizeof(int));
			MyID = ID_CLIENT_TWO;
			printf("Sou o cliente DOIS!\n");
			setWindowTitles("Client TWO !!");
		}
	}
	if (MyID == 0)
	{
		printf("Identificao no definida !!\n");
		ServerOK =0;
		setWindowTitles("Identificao no definida !!");

	}
	ID = MyID; // cliente no conectado

}
// **********************************************************************
// void LeDadosDaMemoriaRemota(double Pos[3], double &rotY)
//
//
// **********************************************************************
void LeDadosDaMemoriaRemota(double Pos[3], double &rotY)
{

	 if (!ServerOK)
		return;

	 if (MyID == ID_CLIENT_ONE)
     {
		 ReadFromRemoteMemoryIP (&Pos[0], POS_CLIENT_TWO*sizeof(double),  3*sizeof(double));	
		 ReadFromRemoteMemoryIP (&rotY, ROT_CLIENT_TWO*sizeof(double),  sizeof(double));	
	 }

	 if (MyID == ID_CLIENT_TWO)
     {
		 ReadFromRemoteMemoryIP (&Pos[0], POS_CLIENT_ONE*sizeof(double),  3*sizeof(double));	
		 ReadFromRemoteMemoryIP (&rotY, ROT_CLIENT_ONE*sizeof(double),  sizeof(double));	
	 }
     
 }
// **********************************************************************
// void GravaDadosNaMemoriaRemota(double Pos[3], double Rot)
//
//
//
// **********************************************************************
void GravaDadosNaMemoriaRemota(double Pos[3], double Rot)
{
    	
	if (!ServerOK)
		return;	

	if (MyID == ID_CLIENT_ONE)
	{
		WriteOnRemoteMemoryIP (&Pos[0], POS_CLIENT_ONE * sizeof(double), 3*sizeof(double));	
		WriteOnRemoteMemoryIP (&Rot, ROT_CLIENT_ONE * sizeof(double), sizeof(double));	
	}
	
	if (MyID == ID_CLIENT_TWO)
	{
		WriteOnRemoteMemoryIP (&Pos[0], POS_CLIENT_TWO * sizeof(double), 3*sizeof(double));	
		WriteOnRemoteMemoryIP (&Rot, ROT_CLIENT_TWO * sizeof(double), sizeof(double));	
	}
	
}

/*
	SmVR_C3DSLoader *Arq3DS = new SmVR_C3DSLoader( );	

	// Define its "shape"
	char AvatarFileName[50];

	if (MyID == ID_CLIENT_ONE)
	{
		//PartnerObject->SetRenderFunctionData(Verde);
		strcpy(AvatarFileName,"C:\\My Documents\\RV\\SmallVR\\TestFiles\\AVC\\Eric.3ds");		
	}
	if (MyID == ID_CLIENT_TWO)
	{
		//PartnerObject->SetRenderFunctionData(Rosa);	 
		strcpy(AvatarFileName,"C:\\My Documents\\RV\\SmallVR\\TestFiles\\AVC\\Kyle.3ds");		
	}

	if (MyID != -1) //
		if (!Arq3DS->Load(AvatarFileName))
		{
			printf ("Error reading file !\n");
			printf ("Program Aborted.\n");
			getchar();
			exit(1);
		}
		
	PartnerObject = new SmVR_CGeometricObject("Partner Object", Arq3DS);
	RootObject->AddChild(PartnerObject);

*/



