/*****************************************************
 **
 **  Remote Memory Library
 **
 **  File: RemoteMemory.h
 **  Author: Marcio S. Pinho e Rafael S. Garcia.
 **  Mail: pinho@inf.pucrs.br,
 **        rafael_sgarcia@terra.com.br
 **  Version: 2.0.
 **
 **  Last Update: 27.January.2003
 **
 *****************************************************/
#include <windows.h>


// Define the ESC key.
#define ESC 27

// Define the memory operations.
#define REMOTE_MEMORY_WRITE 100
#define REMOTE_MEMORY_READ  101
#define REMOTE_MEMORY_REPLY 102

// Define the message size.
#define MAX_BUFF_SIZE 64


// Define the struct with the message data.
typedef struct {
	unsigned char operation;
	unsigned int address;
	BYTE data[MAX_BUFF_SIZE];
	unsigned int nbytes;
} TMSG;


// Define the IP functions.
void WriteOnRemoteMemoryIP  ( void *msg, WORD addr, int n );
void ReadFromRemoteMemoryIP  ( void *message, WORD address, int size );
BOOL ConnectToRemoteMemoryIP  ( char *serverIP, unsigned short port );

// Define the UDP functions.
void WriteOnRemoteMemoryUDP ( void *msg, WORD addr, int n );
void ReadFromRemoteMemoryUDP ( void *message, WORD address, int size );
BOOL ConnectToRemoteMemoryUDP ( char *serverIP, unsigned short port );

// Define the connect function.
int ConnectToRemoteMemory    ( char *serverIP, unsigned short port );

// Define the local memory functions.
void WriteOnLocalMemory ( void *msg, WORD addr, int n );
void ReadFromLocalMemory ( void *msg, WORD addr, int n );


