/*************************************************
 **
 ** Utilities.h
 ** Library with color and other stuffs.
 **
 ** Author: Rafael Saraiva Garcia.
 ** E-Mail: rafael_sgarcia@yahoo.com
 ** Version: 1.0
 ** Date: July 31th, 2002.
 **
 *************************************************/
#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include <GL/glut.h>
#include "../Source/SmVR.h"



/*************************************************
 ** Math Constants.
 *************************************************/
#define PI 3.1415



/*************************************************
 ** Resolution Constants.
 *************************************************/
#define RES_640x480   1
#define RES_800x600   2
#define RES_1024x768  3
#define RES_1400x1050 4



/*************************************************
 ** Colors Constants.
 *************************************************/
// Black, Gray and White.
#define WHITE           1.00, 1.00, 1.00
#define LIGHT_GRAY      0.75, 0.75, 0.75
#define GRAY            0.50, 0.50, 0.50
#define DARK_GRAY       0.25, 0.25, 0.25
#define BLACK           0.00, 0.00, 0.00

// Red.
#define RED             1.00, 0.00, 0.00
#define LIGHT_RED       0.75, 0.00, 0.00
#define MEDIUM_RED      0.50, 0.00, 0.00
#define DARK_RED        0.25, 0.00, 0.00

// Green.
#define GREEN           0.00, 1.00, 0.00
#define LIGHT_GREEN     0.00, 0.75, 0.00
#define MEDIUM_GREEN    0.00, 0.50, 0.00
#define DARK_GREEN      0.00, 0.25, 0.00

// Blue.
#define BLUE            0.00, 0.00, 1.00
#define LIGHT_BLUE      0.00, 0.00, 0.75
#define MEDIUM_BLUE     0.00, 0.00, 0.50
#define DARK_BLUE       0.00, 0.00, 0.25

// Yellow.
#define YELLOW          1.00, 1.00, 0.00
#define LIGHT_YELLOW    0.75, 0.75, 0.00
#define MEDIUM_YELLOW   0.50, 0.50, 0.00
#define DARK_YELLOW     0.25, 0.25, 0.00

// Magenta.
#define MAGENTA         1.00, 0.00, 1.00
#define LIGHT_MAGENTA   0.75, 0.00, 0.75
#define MEDIUM_MAGENTA  0.50, 0.00, 0.50
#define DARK_MAGENTA    0.25, 0.00, 0.25

// Cyan.
#define CYAN            0.00, 1.00, 1.00
#define LIGHT_CYAN      0.00, 0.75, 0.75
#define MEDIUM_CYAN     0.00, 0.50, 0.50
#define DARK_CYAN       0.00, 0.25, 0.25

// Other stuff.
#define BROWN           0.60, 0.40, 0.12
#define PUMPKIN_ORANGE  0.98, 0.625,0.12
#define PASTEL_PINK     0.98, 0.00, 0.47
#define BARNEY_PURPLE   0.60, 0.40, 0.70



/*************************************************
 ** Point 3D Struct.
 *************************************************/
typedef struct Point3D {
	GLfloat x;
	GLfloat y;
	GLfloat z;
} Point3D;



/*************************************************
 ** Functions.
 *************************************************/
void findPoint (Point3D *inPoint, Point3D *outPoint);

void changeResolution (int mode);
void setWindowTitles (char *title);
void removeBorders (void);


void setColor (GLfloat red, GLfloat green, GLfloat blue);
void setBackgroundColor (GLfloat red, GLfloat green, GLfloat blue);


void reshapeFunction (GLsizei width, GLsizei height, GLfloat range);
void keyboardFunction (unsigned char key, int x, int y, GLfloat *xRotate, GLfloat *yRotate, GLfloat *zRotate);
void specialKeyboardFunction (int key, int x, int y, GLfloat *xRotate, GLfloat *yRotate, GLfloat *zRotate);


